
/**
 * Programa para calcular combinaes de n elementos k a k
 * 
 * @author Joo Pascoal Faria 
 * @version 23 de Janeiro de 2003
 */

import javax.swing.JOptionPane;

public class combnk
{
    public static int cnk_rec(int n, int k)
    {
        if (k == n || k == 0)
            return 1;
        else
            return cnk_rec(n-1,k) + cnk_rec(n-1,k-1);
    
    }
    
    // usa frmula: cnk = (n * (n-1) *  ... * (n-k+1)) / (k * (k-1) *  ... * 1)
    public static int cnk_iter(int n, int k)
    {
        long numerador = 1, denominador = 1;
        while(k > 0)
        {
            numerador *= n;
            denominador *= k;
            n--;
            k--;
        }
        
        return (int) (numerador / denominador);
    
    }
    
    public static void main(String args[])
    {
        String input;
        
        input = JOptionPane.showInputDialog("Introduza o valor de n (>0)" );
        int n = Integer.parseInt(input);
        
        input = JOptionPane.showInputDialog("Introduza o valor de k (0 a " + n + ")" );
        int k = Integer.parseInt(input);
 
        JOptionPane.showMessageDialog(null, 
            "Nmero de combinaes (verso recursiva): " + cnk_rec(n,k) + "\n" +
            "Nmero de combinaes (verso iterativa): " + cnk_iter(n,k),
            null, JOptionPane.INFORMATION_MESSAGE );
    }
}
